#ifndef PCL_SEGMETATION_H
#define PCL_SEGMETATION_H

#include <iostream>
#include <pcl/io/pcd_io.h>
#include <pcl/point_types.h>
#include <pcl/sample_consensus/method_types.h>
#include <pcl/sample_consensus/model_types.h>
#include <pcl/segmentation/sac_segmentation.h>
#include <pcl/segmentation/extract_clusters.h>
#include <pcl/filters/extract_indices.h>
#include <pcl/ModelCoefficients.h>
#include <pcl/segmentation/sac_segmentation.h>
#include <pcl/sample_consensus/ransac.h>
#include <pcl/sample_consensus/sac_model_plane.h>
#include <pcl/sample_consensus/sac_model_sphere.h>

class RANSACPlane
{
  public:
    void ransac (pcl::PointCloud<pcl::PointXYZ>::Ptr &cloud,
      pcl::PointCloud<pcl::PointXYZ>::Ptr &cloud_final,
      double distance_threshold);
};


class PlaneSegmentation
{
  public:
    int segment (pcl::PointCloud<pcl::PointXYZ>::Ptr &cloud,
      pcl::PointIndices::Ptr &inliers, pcl::ModelCoefficients::Ptr &coefficients, 
      double sac_distence_threshold, bool print_flag = false);
};


class ExtractClusterOnPlane
{
  public:
    pcl::PointIndices::Ptr inliers_;
    pcl::ModelCoefficients::Ptr coefficients_;
    int cluster_number;

    void extractCluster (pcl::PointCloud<pcl::PointXYZ>::Ptr &cloud,
      std::vector< pcl::PointCloud<pcl::PointXYZ> > &cloud_vector,
      double sac_distence_threshold, double cluster_tolerance,
      int min_cluster_size, int max_cluster_size, int sac_maxiterations=50);

    int outputPlaneCoefficients (pcl::PointIndices::Ptr &inliers,
      pcl::ModelCoefficients::Ptr &coefficients, bool coefficients_print_flag = false);
};


#endif
