#ifndef INCLUDED_ARM_INTERFACE_YOUBOT_H
#define INCLUDED_ARM_INTERFACE_YOUBOT_H


#include <ros/ros.h>
#include <iostream>
#include <sstream>

class cArmInterfaceYoubot
{
public:

	cArmInterfaceYoubot(ros::NodeHandle& nh);
        ~cArmInterfaceYoubot();
	void PublishJointValues(const std::vector<double>& newPositions);
	void PublishGripperValues(double width);
	void OpenGrippers();
	void CloseGrippers();
	void Arm_Recognition_Ready();  //识别准备，手臂down
	void Arm_Upright();  //手臂竖直
	void Arm_Place();  //手臂放置
	void Arm_Grasp(const std::vector<double>& marker_jointvalues,const std::vector<double>& adjust_jointvalues);  //抓取



private:
	ros::Publisher mArmJointsPub;
	ros::Publisher mGripperPub;
	
	const double mGripperWidthAtGrasp;
	const double mGripperWidthOpen;

	std::vector<double> mArm_Rec_PoseVals;
	std::vector<double> mArm_Upright_PoseVals;
	std::vector<double> mArm_Place_PoseVals;


};


#endif

